
// $Id: ToolTipWidget.cpp,v 1.14 2013/04/29 18:27:14 hupereir Exp $

/******************************************************************************
*
* Copyright (C) 2002 Hugo PEREIRA <mailto: hugo.pereira@free.fr>
*
* This is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
*
* This software is distributed in the hope that it will be useful, but WITHOUT
* Any WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
* for more details.
*
* You should have received a copy of the GNU General Public License along with
* this program.  If not, see <http://www.gnu.org/licenses/>.
*
*******************************************************************************/

#include "ToolTipWidget.h"

#include "Debug.h"

#include <QApplication>
#include <QLayout>

//_________________________________________
ToolTipWidget::ToolTipWidget( QWidget* parent ):
    BaseToolTipWidget( parent )
{

    Debug::Throw( "ToolTipWidget::ToolTipWidget.\n" );

    // create objects
    QHBoxLayout *layout = new QHBoxLayout();
    layout->setMargin(10);
    layout->setSpacing(10);
    setLayout( layout );

    layout->addWidget( pixmapLabel_ = new QLabel(this), Qt::AlignTop );
    layout->addWidget( textLabel_ = new QLabel(this) );
    pixmapLabel_->setMargin(10);

    // install event handlers
    qApp->installEventFilter(this);

}


//__________________________________________
bool ToolTipWidget::eventFilter(QObject*, QEvent* event )
{
    switch( event->type() )
    {

        case QEvent::Leave:
        hide();
        break;

        case QEvent::WindowActivate:
        case QEvent::WindowDeactivate:
        case QEvent::MouseButtonPress:
        case QEvent::MouseButtonRelease:
        case QEvent::MouseButtonDblClick:
        case QEvent::FocusIn:
        case QEvent::FocusOut:
        case QEvent::Wheel:
        hide();
        break;

        default:
        break;
    }

    return false;

}
