#ifndef TunnelAttributesModel_h
#define TunnelAttributesModel_h

// $Id: TunnelAttributesModel.h,v 1.6 2013/04/29 18:27:14 hupereir Exp $

/******************************************************************************
*
* Copyright (C) 2002 Hugo PEREIRA <mailto: hugo.pereira@free.fr>
*
* This is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
*
* This software is distributed in the hope that it will be useful, but WITHOUT
* Any WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
* for more details.
*
* You should have received a copy of the GNU General Public License along with
* this program.  If not, see <http://www.gnu.org/licenses/>.
*
*******************************************************************************/

#include "ListModel.h"
#include "TunnelAttributes.h"

//! tunnel attributes model
class TunnelAttributesModel: public ListModel<TunnelAttributes>, public Counter
{

    Q_OBJECT

    public:

    //! number of columns
    enum { nColumns = 3 };

    //! column types
    enum ColumnTypes {
        Local_PORT,
        HOST,
        Remote_PORT
    };

    //! constructor
    TunnelAttributesModel( QObject* parent = 0 ):
        ListModel<TunnelAttributes>( parent ),
        Counter( "ConnectionDialog::TunnelAttributesModel" )
    {}

    //! destructor
    virtual ~TunnelAttributesModel( void )
    {}

    //! data
    virtual QVariant data (const QModelIndex&, int ) const;

    //! header data
    virtual QVariant headerData( int, Qt::Orientation, int = Qt::DisplayRole ) const;

    //! number of columns for a given index
    virtual int columnCount( const QModelIndex& = QModelIndex() ) const
    { return nColumns; }

    protected:

    //! sort
    virtual void _sort( int, Qt::SortOrder = Qt::AscendingOrder )
    {}

    private:

    //! list column names
    static const QString columnTitles_[nColumns];

};

#endif
